;==========================================
; Macro_1wire.asm
;==========================================

;  
TX_data MACRO	TRIS_DS, bit_DS, K
		LOCAL	step_0
		LOCAL	step_1
		LOCAL	step_2
		LOCAL	step_3
		LOCAL	step_4
		LOCAL	step_5
		LOCAL	step_6
		LOCAL	step_7
		LOCAL	ERR_1W

		BCF		INT_ON_1msec, .0

		BTFSC	step_1_wire, .0
		GOTO	step_0
		BTFSC	step_1_wire, .1
		GOTO	step_1
		BTFSC	step_1_wire, .2
		GOTO	step_2
		BTFSC	step_1_wire, .3
		GOTO	step_3
		BTFSC	step_1_wire, .4
		GOTO	step_4
		BTFSC	step_1_wire, .5
		GOTO	step_5
		BTFSC	step_1_wire, .6
		GOTO	step_6
		BTFSC	step_1_wire, .7
		GOTO	step_7
;~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~

step_0:
;~~~~~~~~~~~~~~~ 0-  ~~~~~~~~~~~~~~~~
		RESET_WIRE	;  

		delay_K	.68			;  68 

		;   
		BTFSC	PORT_DS, bit_DS
		GOTO	ERR_1W		; 

		delay_K	.256		;  256 

		MOVLW	b'00000010'
		MOVWF	step_1_wire
		GOTO	main
;~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~

step_1:
;~~~~~~~~~~~~~~~ 1-  ~~~~~~~~~~~~~~~~
		MOVLW	0xCC		;  " ROM"
		MOVWF	DATA_OUT
		TX_byte_1W			;  
		MOVLW	b'00000100'
		MOVWF	step_1_wire
		GOTO	main
;~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~

step_2:
;~~~~~~~~~~~~~~~ 2-  ~~~~~~~~~~~~~~~~
		MOVLW	0xBE		;  " "
		MOVWF	DATA_OUT
		TX_byte_1W			;  
		MOVLW	b'00001000'
		MOVWF	step_1_wire
		GOTO	main
;~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~

step_3:
;~~~~~~~~~~~~~~~ 3-  ~~~~~~~~~~~~~~~~
		RX_byte_1W	;  
		MOVF	DATA_IN, w
		MOVWF	DATA_INL
		MOVLW	b'00010000'
		MOVWF	step_1_wire
		GOTO	main
;~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~

step_4:
;~~~~~~~~~~~~~~~ 4-  ~~~~~~~~~~~~~~~~
		RX_byte_1W	;  
		MOVF	DATA_IN, w
		MOVWF	DATA_INH
		MOVLW	b'00100000'
		MOVWF	step_1_wire
		GOTO	main
;~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~

step_5:
;~~~~~~~~~~~~~~~ 5-  ~~~~~~~~~~~~~~~~
		RESET_WIRE	;  

		delay_K	.68			;  68 

		;   
		BTFSC	PORT_DS, bit_DS
		GOTO	ERR_1W		; 

		delay_K	.256		;  256 
		MOVLW	b'01000000'
		MOVWF	step_1_wire
		GOTO	main
;~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~

step_6:
;~~~~~~~~~~~~~~~ 6-  ~~~~~~~~~~~~~~~~
		MOVLW	0xCC		;  " ROM"
		MOVWF	DATA_OUT
		TX_byte_1W			;  
		MOVLW	b'10000000'
		MOVWF	step_1_wire
		GOTO	main
;~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~

step_7:
;~~~~~~~~~~~~~~~ 7-  ~~~~~~~~~~~~~~~~
		MOVLW	0x44		;  "  "
		MOVWF	DATA_OUT
		TX_byte_1W			;  
		MOVLW	b'00000001'
		MOVWF	step_1_wire
		CALL	ByteToDec
		BCF		INT_ON_5sec, .0
		GOTO	main
;~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~

;  
ERR_1W:
		BCF		INT_ON_5sec, .0

		MOVLW	(0x0D+K)
		MOVWF	Hundreds
		MOVLW	0x00 ; .0
		MOVWF	Tens
		MOVLW	0x0C ; .12
		MOVWF	Ones
		MOVLW	0x0C ; .12
		MOVWF	Tenth
		BCF		FLAG_DS, (.0+K*.4)
		BCF		FLAG_DS, (.1+K*.4)
		BCF		FLAG_DS, (.2+K*.4)
		BCF		FLAG_DS, (.3+K*.4)
		BCF		Znak, (.0+K)
		GOTO	main

		ENDM
;==========================================

;  1 
TX_byte_1W	MACRO
		LOCAL	LOOP_1
		LOCAL	METKA_1
		LOCAL	TX_0
		LOCAL	TX_1
		LOCAL	END_TX_byte

		MOVLW	.8
		MOVWF	COUNT
LOOP_1:
		RRF		DATA_OUT, f		;    
		BTFSC	STATUS, C		;    "C"
		GOTO	TX_1
		GOTO	TX_0
METKA_1:
		DECFSZ	COUNT, f
		GOTO	LOOP_1
		GOTO	END_TX_byte
;~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~

;    "1"
TX_1:
		; PORT_DS, bit_DS   
		PORTout	TRIS_DS, bit_DS
		NOP
		; PORT_DS, bit_DS   
		PORTin	TRIS_DS, bit_DS
		delay_K	.56  			; 180  164
		NOP
		GOTO	METKA_1
;~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~

;    "0"
TX_0:
		; PORT_DS, bit_DS   
		PORTout	TRIS_DS, bit_DS
		delay_K	.36				; 156 
		NOP
		NOP
		NOP
		NOP
		; PORT_DS, bit_DS   
		PORTin	TRIS_DS, bit_DS
		delay_K	.16				; 24 
		NOP
		NOP
		GOTO	METKA_1

END_TX_byte:
		ENDM
;==========================================

;  1 
RX_byte_1W	MACRO
		LOCAL	LOOP_2
		MOVLW	.8
		MOVWF	COUNT
LOOP_2:
		; PORT_DS, bit_DS   
		PORTout	TRIS_DS, bit_DS
		NOP
		; PORT_DS, bit_DS   
		PORTin	TRIS_DS, bit_DS

		delay_K	.4			; 4 

		BCF		STATUS, C
		BTFSC	PORT_DS, bit_DS
		BSF		STATUS, C
		RRF		DATA_IN, f		;     

		delay_K	.60				; 248 

		DECFSZ	COUNT, f
		GOTO	LOOP_2
		ENDM
;==========================================

;     RESET
RESET_WIRE	MACRO
		PORTout	TRIS_DS, bit_DS
		delay_K	.500			; 600 
		PORTin	TRIS_DS, bit_DS
		ENDM
;==========================================

;    
;  PORT_DS, bit_DS  
PORTin	MACRO	TRIS_DS, bit_DS
		BANK1
		BSF		TRIS_DS, bit_DS
		BANK0
		ENDM
;==========================================

;    
;  PORT_DS, bit_DS  
PORTout MACRO	TRIS_DS, bit_DS
		BANK1
		BCF		TRIS_DS, bit_DS
		BANK0
		BCF		PORT_DS, bit_DS
		ENDM
;==========================================


