

#include <p16f628a.inc>
#include <Macro_function.asm>
#include <Macro_1wire.asm>
#include <Macro_DS_definition.asm>

		;__CONFIG _CP_OFF&_WDT_OFF&_PWRTE_ON&_XT_OSC
		;__CONFIG _CP_OFF&_CPD_OFF&_LVP_OFF&_BOREN_OFF&_MCLRE_OFF&_PWRTE_ON&_WDT_OFF&_XT_OSC
		__CONFIG 0x3F10
		;__CONFIG 0x3F30

		CBLOCK	0x20
;      
;  
w_temp			;      
status_temp		;  
;~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~

DATA_IN
DATA_OUT
DATA_INL
DATA_INH

step_indication ;    
step_1_wire		;      

INT_ON_5sec		;    2 
INT_ON_1msec	;    1 
FLAG_DS			;       
; FLAG_DS == xxxxxx01 - 1-    DS18S20
; FLAG_DS == xxxxxx11 - 1-    DS18B20
; FLAG_DS == xxxx01xx -   1-  
; FLAG_DS == xxxx11xx -   1-  
; FLAG_DS == xx01xxxx - 2-    DS18S20
; FLAG_DS == xx11xxxx - 2-    DS18B20
; FLAG_DS == 01xxxxxx -   2-  
; FLAG_DS == 11xxxxxx -   2-  

Num_DS			; 
; Num_DS == xxxxxxx0 - 0- 
; Num_DS == xxxxxxx1 - 1- 

Hundreds		; 
Tens			; 
Ones			; 
Tenth			; 
Minus			;  ""
Znak			;  ""
; Znak == xxxxxxx1 -  ""   1- 
; Znak == xxxxxx1x -  ""   2- 

COUNT
COUNT0
COUNT1
		ENDC

;==========================================

PORT_DS		EQU	PORTA
PORT_LED	EQU	PORTB
PORT_CAT	EQU	PORTA
PORT_Err	EQU	PORTA
TRIS_DS		EQU TRISA

bit_DS0		EQU	.4
bit_DS1		EQU	.6

;==========================================

		ORG		0x000
		GOTO	START

		ORG		0x004
		GOTO	INTERRUPT
;==========================================

START
;  PORTA
		BANK0
		CLRF	PORTA
		MOVLW	0x07
		MOVWF	CMCON
		BANK1
		CLRF	TRISA
		BSF		TRISA, bit_DS0		; PORT_DS, bit_DS  ,   
		BSF		TRISA, bit_DS1		; PORT_DS, bit_DS  ,   
		BANK0

;  PORTB
		CLRF	PORTB
		BANK1
		MOVLW   b'00000000'
		MOVWF	TRISB				;  PORT  
		BANK0
;==========================================

;   0
;  
		BCF		INTCON, T0IF		;   T0IF -   TMR0
		CLRF	TMR0
		;  0
		BANK1						; 1
		MOVLW   b'00000001' 		;  1:16
		MOVWF   OPTION_REG
		BANK0
;==========================================

;  
		MOVLW	(1<<GIE)|(1<<T0IE) 	;   
		MOVWF	INTCON				;      
;==========================================

;   

		GOTO	JUMP

;==========================================
;       
;conv_data:
;		addwf 	PCL, f	; dec ; hex  ; 
;		retlw	0x3F	;  0  ; 0x00 ; "0"
;		retlw	0x06	;  1  ; 0x01 ; "1"
;		retlw	0x5B	;  2  ; 0x02 ; "2"
;		retlw	0x4F	;  3  ; 0x03 ; "3"
;		retlw	0x66	;  4  ; 0x04 ; "4"
;		retlw	0x6D	;  5  ; 0x05 ; "5"
;		retlw	0x7D	;  6  ; 0x06 ; "6"
;		retlw	0x07	;  7  ; 0x07 ; "7"
;		retlw	0x7F	;  8  ; 0x08 ; "8"
;		retlw	0x6F	;  9  ; 0x09 ; "9"
;		retlw	0x00	; 10  ; 0x0A ;  
;		retlw	0x40	; 11  ; 0x0B ; "-"
;		retlw	0x71	; 12  ; 0x0C ; "F"
;		retlw	0x10	; 13  ; 0x0D ; "i"
;		retlw	0x14	; 14  ; 0x0E ; "ii"

conv_data:
;    
		addwf 	PCL, f	; dec ; hex  ; 
		retlw	0xF6	;  0  ; 0x00 ; "0"
		retlw	0x84	;  1  ; 0x01 ; "1"
		retlw	0xE3	;  2  ; 0x02 ; "2"
		retlw	0xC7	;  3  ; 0x03 ; "3"
		retlw	0x95	;  4  ; 0x04 ; "4"
		retlw	0x57	;  5  ; 0x05 ; "5"
		retlw	0x77	;  6  ; 0x06 ; "6"
		retlw	0xC4	;  7  ; 0x07 ; "7"
		retlw	0xF7	;  8  ; 0x08 ; "8"
		retlw	0xD7	;  9  ; 0x09 ; "9"
		retlw	0x00	; 10  ; 0x0A ;  
		retlw	0x01	; 11  ; 0x0B ; "-"
		retlw	0x71	; 12  ; 0x0C ; "F"
		retlw	0x20	; 13  ; 0x0D ; "i"
		retlw	0x24	; 14  ; 0x0E ; "ii"

;      
conv_tenth:
		addwf 	PCL, f	; dec ;	hex  ;
		retlw	.0		;  0  ;	0x00 ;
		retlw	.1		;  1  ;	0x01 ;
		retlw	.1		;  2  ;	0x02 ;
		retlw	.2		;  3  ;	0x03 ;
		retlw	.2		;  4  ;	0x04 ;
		retlw	.3		;  5  ;	0x05 ;
		retlw	.3		;  6  ;	0x06 ;
		retlw	.4		;  7  ;	0x07 ;
		retlw	.5		;  8  ;	0x08 ;
		retlw	.6		;  9  ;	0x09 ;
		retlw	.6		; 10  ;	0x0A ;
		retlw	.7		; 11  ;	0x0B ;
		retlw	.7		; 12  ;	0x0C ;
		retlw	.8		; 13  ;	0x0D ;
		retlw	.9		; 14  ;	0x0E ;
		retlw	.9		; 15  ;	0x0F ;
;==========================================

JUMP:
		CLRF	PORT_LED
		MOVLW	b'00001111'
		MOVWF	PORT_CAT

		MOVLW	b'00000001'
		MOVWF	step_indication
		MOVWF	step_1_wire

		CLRF	DATA_INL
		CLRF	DATA_INH
		CLRF	INT_ON_5sec		;    2 
		CLRF	INT_ON_1msec	;    1 
		CLRF	FLAG_DS
		CLRF	Num_DS
		BSF		Num_DS, .0

		MOVLW	0x0B
		MOVWF	Hundreds		; 
		MOVWF	Tens			; 
		MOVWF	Ones			; 
		MOVWF	Tenth			;   
		CLRF	Minus			;  ""
		CLRF	Znak			;  ""

		CLRF	COUNT
		MOVLW	.100
		MOVWF	COUNT0
		MOVLW	.4
		MOVWF	COUNT1

		#include <Main.asm>
		#include <ByteToDec.asm>
		#include <Indication.asm>
;==========================================

; 
INTERRUPT
;  
		MOVWF	w_temp
		SWAPF	STATUS, w
		MOVWF	status_temp

		BTFSS	Num_DS, .0
		GOTO	SF0
		GOTO	SF1
SF0:	Setflag	.0
		GOTO	loop
SF1:	Setflag	.1

loop:
		CALL	Indication
		;~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~

		;      STATUS
		;      
		SWAPF	status_temp, w
		MOVWF	STATUS
		SWAPF	w_temp, f
		SWAPF	w_temp, w

		;   
		BCF		INTCON, T0IF

		;    TMR0 0
		;CLRF 	TMR0

		RETFIE
;==========================================

		END
;==========================================